import sys
import os
forge = sys.modules["forge"]

def setup(module):

	# the library
	srcList = [	"DebugController",
				"DrawSelection",
				"DrawView",
				"EventMap",
				"InspectController",
				"Intersectors",
				"Mask",
				"MaskMap",
				"ObjectViewer",
				"OrthoViewer",
				"PerspectiveViewer",
				"PickPoint",
				"ProjectPoint",
				"QuickViewer",
				"SelectController",
				"VideoRecorder",
				"ChannelFilter",
				"ChannelController",
				"ChannelBinder",
				"WindowController",
				"viewerLib"
				]

	forge.objlists['viewer'] = module.SrcToObj(srcList)

	lib = module.Lib("fexViewer",srcList)

	# the plugin
	srcList = [	"viewer.pmh",
				"viewerDL" ]

	dll = module.DLL( "fexViewerDL", srcList )

	dll.linkmap = { "gfxlibs": forge.gfxlibs }

	deplibs = forge.corelibs+ [
				"fexViewerLib",
				"feSignalLib",
				"fexDataToolDLLib",
				"fexMathLib",
				"fexWindowLib",
				"fexWindowDLLib" ]

	forge.deps( ["fexViewerDLLib"], deplibs )

	forge.tests += [
		("inspect.exe",		"fexViewerDL",					None,		None) ]

	module.Module( 'test' )
